% Sine wave
clear
clf
t=0:0.01:9.99;
w=sin(2*pi*t/8);
plot(t,w)
q=axis;
plot(0.8*t,0.8*w)
axis('off')
hold on
plot([q(1) q(2)],[0 0],'-')
plot([0 0],[q(3) q(4)],'-')
pause
axis;
clf
%make_eps('sin1')

% Autocorrelation
w=0.5*cos(2*pi*t/8);
plot(t,w)
q=axis;
plot(0.8*t,0.8*w)
axis('off')
hold on
plot([q(1) q(2)],[0 0],'-')
plot([0 0],[q(3) q(4)],'-')
pause
axis;
clf
%make_eps('sin2')

% Frequency spectrum
sp=zeros(1,201);
sp(101)=1;
linechart(sp)
q=axis;
plot([101],[0.8],'o')
axis('off')
hold on
plot([101 101],[0 0.8],'-')
plot([q(1) q(2)],[0 0],'-')
plot([0 0],[q(3) q(4)],'-')
pause
axis;
clf
%make_eps('sin3')

% P.D.F.
%t=0:.0001:191.999; 
%w=sin(2*pi*t/8);
%[a,b]=hist(w,400);
load pdf600
aa=a(2:length(a)-1);
aaa=aa;
for k=2:length(aa)-1
    aaa(k)=mean(aa(k-1:k+1));
end
aa=aaa;
clear aaa
bb=b(2:length(aa)+1);
plot(bb,aa)
q=axis;
plot(0.8*bb,0.8*aa)
axis('off')
hold on
plot([q(1) q(2)],[0 0],'-')
plot([0 0],[q(3) q(4)],'-')
plot([0.8*q(1) 0.8*q(1)],[q(3) 0.8*max(aa)])
plot([0.8*q(2) 0.8*q(2)],[q(3) 0.8*max(aa)])
pause
clf
%make_eps('sin4')

% C.D.F.
N=max(size(b));
cdf(1)=a(1)/N;
for i=2:N
    cdf(i)=cdf(i-1)+a(i)/N;
end
plot(b,cdf)
q = axis;
plot(0.7*b,0.8*cdf)
axis('off')
hold on
plot([q(1) q(2)],[0 0],'-')
plot([0 0],[q(3) q(4)],'-')
plot([0.7*q(1) 0.7*q(1)], [0 0.8*min(cdf)])
plot([0.7*q(2) 0.8*q(2)],[0.8*max(cdf) 0.8*max(cdf)])
pause
%make_eps('sin5')
axis;
clf
