% Pulse wave
clear
clf
t=0:0.001:1.6;
w=0.9*square(2*pi*t,10);
plot(t,w)
q=axis;
axis([0.0 2.0 q(3) q(4)])
q=axis;
plot(t,w)
axis('off')
hold on
plot([q(1) q(2)],[0 0])
plot([q(1) q(1)],[q(3) q(4)])
pause
axis;
clf
%make_eps('pu1')

% Autocorrelation
N=1/0.001;  
for j=1:0.1*N
    aux(j)=(0.5-j/(0.1*N))*2;
    aux(0.9*N+j)=(j/(0.1*N)-0.5)*2;
end
aux(0.1*N+1:0.9*N)=-ones(1,length(0.1*N+1:0.9*N)); 
aux(N+1:1.1*N)=aux(1:0.1*N); 
aux(1.1*N+1:1.2*N)=-ones(1,length(1.1*N+1:1.2*N));
t=0:0.001:1.199;
plot(1.2*t,aux)
q=axis;
plot(t,0.9*aux)
axis('off')
hold on
plot([q(1) q(2)],[0 0])
plot([0 0],[q(3) q(4)])
pause
axis;
clf
%make_eps('pu2')

% Spectrum
P=100;
index=1:1650;
delta=zeros(1,length(index));
sp=abs(sin(2*pi*index/2400)./(2*pi*index/2400));
env=sp;
for j=1:1650
    if rem(j,P)==0
        delta(j)=1;
    end
end
sp=sp.*delta;
plot(index,sp)
q=axis;
plot([q(1) q(1)],[q(3) q(4)])
axis('off')
hold on
plot([q(1) q(2)],[q(3) q(3)])
plot(index,0.9*env,'--')
for j=1:1650
    if  rem(j,P)==0
        plot([j j],[q(3) 0.9*sp(j)])
    end
end
pause
axis;
clf
%make_eps('pu3')

% P.D.F.
t=0:0.001:0.999;
w=0.9*square(2*pi*t,10);
[a,b]=hist(w,200);
plot(b,a)
q=axis;
plot([q(1) q(2)],[0 0],'-')
axis('off')
hold on
plot([0 0],[q(3) q(4)],'-')
plot([0.8*q(1) 0.8*q(1)],[q(3) 0.8*max(a)])
plot([0.8*q(2) 0.8*q(2)],[q(3) 0.8*a(length(b))])
pause
axis;
clf
%make_eps('pu4')

% C.D.F.
N=max(size(b));
cdf(1)=a(1)/N;
for i=2:N
    cdf(i)=cdf(i-1)+a(i)/N;
end
plot(b,cdf)
q = axis;
axis([q(1) q(2) 0 q(4)])
plot(0.8*b,0.8*cdf)
axis('off')
hold on
plot([q(1) q(2)],[0 0],'-')
plot([0 0],[0 q(4)],'-')
plot([0.8*b(1) 0.8*b(1)],[0 0.8*min(cdf)])
plot([0.8*b(N) 0.9*b(N)],[0.8*max(cdf) 0.8*max(cdf)])
pause
axis;
clf
%make_eps('pu5')
