% Sawtooth wave
clear
clf
t=0:0.001:2.2;
w=-sawtooth(2*pi*t);
plot(t,w)
q=axis;
plot(t,0.9*w)
axis('off')
hold on
plot([q(1) q(2)],[0 0])
plot([0 0],[q(3) q(4)])
pause
axis;
clf
%make_eps('saw1')

% Autocorrelation
t=0:0.001:2.828 ;
y=t.^2/4-t/sqrt(2)+1/3;
w=[y y];
plot(w)
q=axis;
plot([0  8000], [0 0] )
axis('off')
hold on
plot([0 0], [q(3) q(4)])
plot(w)
pause
axis;
clf
%make_eps('saw2')


% Spectrum
P=1/0.01;
index=1:750;
sp=zeros(1,750);
for j=1:750
    n=j/P;
    if  rem(j,P)==0
        sp(j)=1/n;
    end
end
plot(index,sp)
q=axis;
plot([q(1) q(1)],[q(3) q(4)])
axis('off')
hold on
plot([q(1) q(2)],[q(3) q(3)])
I=1:0.01:max(index/P);
env=1 ./(I);
plot(index(100:750),0.9*env,'--')
for j=1:750
    n=j/P;
    if  rem(j,P)==0
        plot([j j],[q(3) 0.9*sp(j)])
    end
end
pause
axis;
clf
%make_eps('saw3')

% P.D.F.
t=0:0.001:0.999;
w=0.9*sawtooth(2*pi*t);        
[a,b]=hist(w,200);
plot(b,a)
q=axis;
axis([q(1) q(2) 0 q(4)])
plot([q(1) q(2)],[0 0],'-')
axis('off')
hold on
plot([0 0],[0 q(4)],'-')
plot([0.8*q(1) 0.8*q(1)],[0 max(a)])
plot([0.8*q(2) 0.8*q(2)],[0 max(a)])
plot([0.8*q(1) 0.8*q(2)],[max(a) max(a)])
pause
axis;
clf
%make_eps('saw4')

% C.D.F.
N=max(size(b));
cdf(1)=a(1)/N;
for i=2:N
    cdf(i)=cdf(i-1)+a(i)/N;
end
plot(b,cdf)
q = axis;
axis([q(1) q(2) 0 q(4)])
plot([q(1) q(2)],[0 0],'-')
axis('off')
hold on
plot([0 0],[0 q(4)],'-')
plot([0.8*q(1) 0.8*q(2)],[0 0.8*max(cdf)])
plot([0.8*q(2) 0.9*q(2)],[0.8*max(cdf) 0.8*max(cdf)])
pause
axis;
clf
%make_eps('saw5')
