% Square wave
clear
clf
t=0.25:0.001:1.6;
w=0.9*square(2*pi*t);
plot(t,w)
q=axis;
axis([0.25 2.0 q(3) q(4)])
q=axis;
plot(t,w)
axis('off')
hold on
plot([q(1) q(2)],[0 0])
plot([q(1) q(1)],[q(3) q(4)])
pause
axis;
clf
%make_eps('sq1')

% Autocorrelation
t=0:0.001:1.2;
w=0.9*square(2*pi*t);
N=length(w);
aux(1)=w(1);
for i=2:N
    aux(i)=aux(i-1)+w(i);
end 
aux=(0.5-aux/max(aux))*2;        
plot(t,aux)
q=axis;
plot(0.8*t,0.9*aux)
axis('off')
hold on
plot([q(1) q(2)],[0 0])
plot([0 0],[q(3) q(4)])
pause
axis;
clf
%make_eps('sq2')

% Spectrum
P=1/0.01;
index=1:750;
sp=zeros(1,750);
for j=0:750
    n=j/P;
    if  rem(j,P)==0 & rem(n,2) ~= 0
        sp(j)=abs((-1)^n/(2*n+1));
    end
end
plot(index,sp)
q=axis;
plot([q(1) q(1)],[q(3) q(4)])
axis('off')
hold on
plot([q(1) q(2)],[q(3) q(3)])
I=1:0.01:max(index/P);
env=1 ./(2*I+ones(1,length(I)));
plot(index(100:750),0.9*env,'--')
for j=0:750
    n=j/P;
    if  rem(j,P)==0 & rem(n,2) ~= 0
        plot([j j],[q(3) 0.9*sp(j)])
    end
end
pause
axis;
clf
%make_eps('sq3')

% P.D.F.
t=0:0.001:0.999;
w=square(2*pi*t);
[a,b]=hist(w,200);
plot(b,a)
q=axis;
plot([q(1) q(2)],[0 0],'-')
axis('off')
hold on
plot([0 0],[q(3) q(4)],'-')
plot([0.8*q(1) 0.8*q(1)],[q(3) 0.8*max(a)])
plot([0.8*q(2) 0.8*q(2)],[q(3) 0.8*max(a)])
pause
axis;
clf
%make_eps('sq4')

% C.D.F.
N=max(size(b));
cdf(1)=a(1)/N;
for i=2:N
    cdf(i)=cdf(i-1)+a(i)/N;
end
plot(b,cdf)
q = axis;
axis([q(1) q(2) 0 q(4)]);
plot(0.7*b,0.8*cdf)
axis('off')
hold on
plot([q(1) q(2)],[0 0],'-')
plot([0 0],[0 q(4)],'-')
plot([0.7*q(1) 0.7*q(1)],[0 0.8*min(cdf)])
plot([0.7*q(2) 0.8*q(2)],[0.8*max(cdf) 0.8*max(cdf)])
pause
axis;
clf
%make_eps('sq5')
