% Triangular wave
clear
clf
t=0:0.001:1.499;
w=0.9*square(2*pi*t);
N=length(w);
aux(1)=w(1);
for i=2:N
    aux(i)=aux(i-1)+w(i);
end 
aux=(aux/max(aux)-0.5)*2;        
plot(1.2*t,aux)
q=axis;
plot(t,0.9*aux)
axis('off')
hold on
plot([q(1) q(2)],[0 0])
plot([0 0],[q(3) q(4)])
pause
axis;
clf
%make_eps('tr1')

% Autocorrelation
t1=0.000:0.001:2/sqrt(3);
y1=-(t1.^2)/4+1/3;
t2=2/sqrt(3):0.001:6/sqrt(3);
y2=(t2.^2)/4-2*t2/sqrt(3)+1;
t3=6/sqrt(3):0.001:8/sqrt(3);
y3=-(t3.^2)/4+4*t3/sqrt(3)-5;
w=[y1 y2 y3];
plot(w)
q=axis;
plot([0 8000], [0 0])
axis('off')
hold on
plot([0 0], [q(3) q(4)])
plot(w)
pause
axis;
clf
%make_eps('tr2')

% Spectrum
P=100;
index=1:750;
sp=zeros(1,750);
for j=1:750
    n=(j-1)/P;
    if  rem(j-1,P)==0 & rem(n,2) ~= 0
        sp(j)=1/n^2;
    end
end
plot(index,sp)
q=axis;
plot([q(1) q(1)],[q(3) q(4)])
axis('off')
hold on
plot([q(1) q(2)],[q(3) q(3)])
I=1:0.01:max(index/P);
env=1 ./(I.^2);
plot(index(100:750),0.9*env,'--')
for j=1:750
    n=(j-1)/P;
    if  rem(j-1,P)==0 & rem(n,2) ~= 0
        plot([j j],[q(3) 0.9*sp(j)])
    end
end
pause
axis;
clf
%make_eps('tr3')

% P.D.F.
t=0:0.001:0.999;
w=0.9*square(2*pi*t);
N=length(w);
aux(1)=w(1);
for i=2:N
    aux(i)=aux(i-1)+w(i);
end 
aux=(aux/max(aux)-0.5)*2;        
[a,b]=hist(aux,200);
plot(b,a)
q=axis;
axis([q(1) q(2) 0 q(4)])
plot([q(1) q(2)],[0 0],'-')
axis('off')
hold on
plot([0 0],[0 q(4)],'-')
plot([0.8*q(1) 0.8*q(1)],[0 0.8*max(a)])
plot([0.8*q(2) 0.8*q(2)],[0 0.8*max(a)])
plot([0.8*q(1) 0.8*q(2)],[0.8*max(a) 0.8*max(a)])
pause
axis;
clf
%make_eps('tr4')

% C.D.F.
N=max(size(b));
cdf(1)=a(1)/N;
for i=2:N
    cdf(i)=cdf(i-1)+a(i)/N;
end
plot(b,cdf)
q = axis;
axis([q(1) q(2) 0 q(4)])
plot([q(1) q(2)],[0 0],'-')
axis('off')
hold on
plot([0 0],[0 q(4)],'-')
plot([0.8*q(1) 0.8*q(2)],[0 0.8*max(cdf)])
plot([0.8*q(2) 0.9*q(2)],[0.8*max(cdf) 0.8*max(cdf)])
pause
axis;
clf
%make_eps('tr5')
