%
% Callback function for Property button of LP analysis window
% Author : Minkyu Lee
% Date : 1-Mar-1995
%Modified by Karthik May 27 1997


PV=[2 90 292 307];
s2 = 'ARMA analysis Properties ';

% Open analysis window
while exist('arma_pr_win_h')==1
   try = 'get(arma_pr_win_h,''position'');';
   eval(try,catch);
   if check ==0
      clear arma_pr_win_h;
      check = 1;
      break;
   end
   s1 = get(arma_pr_win_h,'Name');
   if ~strcmp(s1,s2)
      clear arma_pr_win_h;
      break;
   end
   figure(arma_pr_win_h);
   break;
end;

if exist('arma_pr_win_h')~=1;

   arma_pr_win_h=figure('Position',PV,...
      'Resize','on',...
      'Numbertitle','off',...
      'color',BACK_COLOR,...
      'Name',s2);
   
   arma_pr_txt3_fl_h=uicontrol('Style','pushbutton',...
      'Position',[10 270 130 30],...
      'String','Frame length');
   
   arma_pr_txt4_fl_h=uicontrol('Style','edit',...
      'Position',[150 275 40 20],...
      'String',arma_frame_len,...
      'Callback','arma_pr_fl_ed');
   
   arma_pr_fl_h=uicontrol('Style','slider',...
      'Position',[190 275 90 20],...
      'Max',12,...
      'Min',4,...
      'Value', log(arma_frame_len)/log(2),...
      'Callback','arma_pr_fl_sl');
   
   arma_pr_txt1_np_h=uicontrol('Style','pushbutton',...
      'Position',[10 220 130 30],...
      'String','Number of poles');
   
   arma_pr_txt2_np_h=uicontrol('Style','edit',...
      'Position',[150 225 40 20],...
      'String',arma_num_poles,...
      'Callback','arma_pr_np_ed');
   
   arma_pr_np_h=uicontrol('Style','slider',...
      'Position',[190 225 90 20],...
      'Max',max_np,...
      'Min',1,...
      'Value', arma_num_poles,...
      'Callback','arma_pr_np_sl');
   
   arma_pr_txt1_nz_h=uicontrol('Style','pushbutton',...
      'Position',[10 170 130 30],...
      'String','Number of zeros');
   
   arma_pr_txt2_nz_h=uicontrol('Style','edit',...
      'Position',[150 175 40 20],...
      'String',arma_num_zeros,...
      'Callback','arma_pr_nz_ed');
   
   arma_pr_nz_h=uicontrol('Style','slider',...
      'Position',[190 175 90 20],...
      'Max',max_nz,...
      'Min',1,...
      'Value', arma_num_zeros,...
      'Callback','arma_pr_nz_sl');
   
   arma_pr_swin_h=uicontrol('Style','popup',...
      'Position',[10 120 130 30],...
      'String','Hamming|Hanning|Kaiser|Triangular|Bartlett|Blackman|Rectangular|Chebyshev',...
      'Value',arma_window);
     
   arma_pr_pzplot_h=uicontrol('Style','checkbox',...
      'Position',[10 70 130 30],...
      'String','Pole-Zero plot',...
      'Value',pzplot_flag);
   
   arma_pr_sel_h=uicontrol('Style','checkbox',...
      'Position',[150 70 130 30],...
      'String','Select starting point',...
      'Value',freq_arma_mark_flag);
   
      arma_pr_save_h=uicontrol('Style','pushbutton',...
      'Position',[10 20 130 30],...
      'String','Apply',...
      'Callback','fr_pr_ok');
   
   arma_pr_cancel_h=uicontrol('Style','pushbutton',...
      'Position',[150 20 130 30],...
      'String','Cancel',...
      'Callback','fr_pr_ca');
end;
