% 
% function r = correlat(n,lag,mode,x,y)
%
% Calculates correlation coefficients
% 
% n	; number of data samples
% lag	; number of correlation samples desired
% mode 	; 0 for unbiased , otherwise biased estimates
% x,y	; complex data of dimension n X 1
%

function r = correlat(n,lag,mode,x,y)
      
for k=0:lag-1
      	nk=n-k;
      	sum=0.;
      	for j=1:nk
    		sum=sum+conj(x(j))*y(j+k);
	end
      	if mode == 0
		r(k+1)=sum/(n-k);
	else
		r(k+1)=sum/n;
	end
end
