% computes the cosine weightings for the Inverse Discrete Fourier Transfrom
% function [wcos] =  plp_cosf(m, nfilt)
%
% m    (in): order of plp auto regressive model
% nfilt(in):
% wcos (out): cosine weightings of inverse dft
%
 
function [wcos] =  plp_cosf(m, nfilt)
for ii = 1:m+1 
	for jj = 2:nfilt-1 
	    wcos(jj,ii) = 2.0 * cos(2.0*pi*(ii-1)*(jj-1)/(2.0*(nfilt-1)));
	end 
	wcos(nfilt,ii) = cos(2.0*pi*(ii-1)*(jj-1)/(2.0*(nfilt-1)));
end 
