%
% A Graphic User Interface to Glottal Inverse Filtering Algorithms
% Author : Minkyu Lee
% Date : 29-Sep-1994
%
%Modified  by Karthik on 05/07/97 

close all;
clear;
clc;

path(path,'./main');
path(path,'./util');
path(path,'./time');
path(path,'./freq');
path(path,'./freq/slider');
% Define some global variables

global Ts;        %Sampling period in seconds
Ts = 1e-4;

num_poles = 14;	% Default number of poles
max_np = 20;   	% Maximum number of poles
min_np=1;      	% Minimum number of poles
num_zeros=4;   	% Default number of zeros
max_nz=20;     	% Maximum number of zeros
min_nz=0;      	% Minimum number of zeros

pzplot_flag=1;		% Default is to plot the pole-zero plot
spec_flag=0;		% Default is not to plot the spectrogram
egg_flag=0;	   	% If set, the program aborts
asyn_flag=0;		% Default is to do asynchronous analysis
iter_flag=1;		% Default is to do iterative analysis
arma_flag=1;		% Default is to do ARMA analysis
clpc_flag=0;		% Default is not to do closed phase LP analysis

check = 1;        %Variable used for proper closing and opening of windows
catch = 'check = 0;';
catch1 = 'break;';
zoom_level =1;

%color_flag=0;		% Black background and white text
color_flag=1;		% White background and black text

global BACK_COLOR TEXT_COLOR;	

if color_flag == 1
	BACK_COLOR=[1 1 1];
	TEXT_COLOR=[0 0 0];
else
	BACK_COLOR=[0 0 0];
	TEXT_COLOR=[1 1 1];
end


ff = [ 500 1500 2500 3500 5000 ];
fb = [ 200 200 200 200 200 ];

gain=200;      	% Default gain in dB

% Define some character strings
o_fname='';
o_pname='';

if exist('vgif-init.mat') == 2
	load vgif-init
end

PV=[2 420 170 100];

m_win_h=figure('Position',PV,...
		'Resize','on',...
		'Numbertitle','off',...
		'color',BACK_COLOR,...
      'Name','Main');
   
m_pb_file_h=uicontrol('Style','pushbutton',...
         'Position',[10 65 70 30],...
			'String','File',...
			'Callback','m_file');

m_pb_edit_h=uicontrol('Style','pushbutton',...
         'Position',[90 65 70 30],...
			'String','Edit',...
			'Callback','m_edit',...
			'Visible','on');

m_pb_anal_h=uicontrol('Style','pushbutton',...
         'Position',[10 20 70 30],...
			'String','Analysis',...
			'Callback','m_anal',...
			'Visible','on');


m_pb_quit_h=uicontrol('Style','pushbutton',...
			'Position',[90 20 70 30],...
			'String','Quit',...
			'Callback','m_quit',...
			'Visible','on');

