%
% Callback function for Time analysis button in the Analysis window
% Author : Minkyu Lee
% Date : 4-Feb-1995
%

%Modified 05/12/97 : window button included.

% If the end points of analysis frame is not defined, return
if exist('LEFT') ~=1 | exist('RIGHT') ~= 1
	disp('Please load an input speech first');
	return;
end

time_mark_flag=1;
time_frame_len=256;
overlap=10;
window_type = 1;
thresh = 50;
time_overlap = round(overlap*time_frame_len/100);
ti_mark_flag=0;        %Intialization and default value


% Set position and size of analysis window
PV=[2 234 287 154];
s2 = 'Time Domain Analysis';

% Open analysis window	
while exist('time_an_win_h')==1
   try = 'get(time_an_win_h,''position'');';
   eval(try,catch);
   if check ==0
      clear time_an_win_h;
      check = 1;
      break;
   end
   s1 = get(time_an_win_h,'Name');
   if ~strcmp(s1,s2)
      clear time_an_win_h;
      break;
   end;
   figure(time_an_win_h);
   break;
end;

if exist('time_an_win_h') ~= 1
   time_an_win_h=figure('Position',PV,...
      'Resize','on',...
      'Numbertitle','off',...
      'Color',BACK_COLOR,...
      'Name',s2);
   

   time_win_h=uicontrol('Style','pushbutton',...
      'Position',[10 120 130 30],...
      'String','Windowing',...
      'Callback','ti_win');
   
   
   time_ez_h=uicontrol('Style','pushbutton',...
      'Position',[150 120 130 30],...
      'String','Energy and ZCR',...
      'Callback','ti_e_zcr');
   
   
   time_method3_h=uicontrol('Style','pushbutton',...
      'Position',[10 70 130 30],...
      'String','Autocorrelation',...
      'Callback','auto_go');
   
   time_prop_h=uicontrol('Style','pushbutton',...
      'Position',[150 70 130 30],...
      'String','Property',...
      'Callback','ti_pr');
   
   time_save_h=uicontrol('Style','popup',...
      'Position',[10 15 130 30],...
      'String','Save Energy|Save ZCR|Save Autocorrelation',...
      'Callback','ti_save');
      
   time_can_h=uicontrol('Style','Pushbutton',...
      'Position',[150 20 130 30],...
      'String','Cancel',...
      'Callback','ti_ok');
end;
   