%
% Callback function for property button in the time analysis window
% Author : Minkyu Lee
% Date : 4-Feb-1995
%

% Set position and size of analysis window

PV=[2 99 310 316];
s2 = 'Time Domain Analysis - Property';

% Open analysis window	
while exist('time_pr_win_h')==1
   try = 'get(time_pr_win_h,''position'');';
     eval(try,catch);
   if check ==0
      clear time_pr_win_h;
      check = 1;
      break;
   end
   s1 = get(time_pr_win_h,'Name');
   if ~strcmp(s1,s2)
      clear time_pr_win_h;
      break;
   end;
   figure(time_pr_win_h);
   break;
end;


if exist('time_pr_win_h') ~= 1
   
   time_pr_win_h=figure('Position',PV,...
      'Resize','on',...
      'Numbertitle','off',...
      'color',BACK_COLOR,...
      'Name',s2);
   

   time_txt_fl_h = uicontrol('Style','Pushbutton',...
      'Position',[10 270 100 30],...
      'String','Window Length');
   
   time_txt1_h = uicontrol('Style','Edit',...
      'Position',[120 270 40 30],...
      'String',time_frame_len,...
      'Callback','ti_pr_edit');
   
   time_fl_sl_h= uicontrol('Style','slider',...
      'Position',[180 270 120 30],...
      'Max',2048,...
      'Min',4,...
      'Value',time_frame_len,...
      'Callback','ti_pr_sl');
   
   ti_ov_txt_fl_h = uicontrol('Style','Pushbutton',...
      'Position',[10 220 100 30],...
      'String','Overlap%');
   
   ti_ov_txt1_h = uicontrol('Style','Edit',...
      'Position',[120 220 40 30],...
      'String',overlap,...
      'Callback','ti_ov_edit');
   
   ti_ov_fl_h= uicontrol('Style','slider',...
      'Position',[180 220 120 30],...
      'Max',99,...
      'Min',0,...
      'Value',overlap,...
      'Callback','ti_ov_sl');
     
   
   ti_thresh_txt_fl_h = uicontrol('Style','Pushbutton',...
      'Position',[10 170 100 30],...
      'String','Threshold%');
   
   ti_thresh_txt1_h = uicontrol('Style','Edit',...
      'Position',[120 170 40 30],...
      'String',thresh,...
      'Callback','ti_thresh_edit');
   
   ti_thresh_fl_h= uicontrol('Style','slider',...
      'Position',[180 170 120 30],...
      'Max',99,...
      'Min',0,...
      'Value',thresh,...
      'Callback','ti_thresh_sl');
   
   
   ti_win_txt3_h = uicontrol('Style','Pushbutton',...
      'Position',[10 120 130 30],...
      'String','Window Type');
   
   ti_win_type_h = uicontrol('Style','popup',...
      'Position',[150 120 150 30],...
      'String','Hamming|Hanning|Kaiser|Triangular|Bartlett|Blackman|Rectangular|Chebyshev',...
      'Value',window_type);
   
   ti_pr_sel_h=uicontrol('Style','checkbox',...
      'Position',[10 75 290 30],...
      'String','Select starting point for autocorrelation',...
      'Value',ti_mark_flag);

   
   time_pb_go_h=uicontrol('Style','pushbutton',...
      'Position',[10 20 130 30],...
      'String','Apply',...
      'Callback','ti_pr_go');
   
   time_pb_ok_h=uicontrol('Style','pushbutton',...
      'Position',[150 20 130 30],...
      'String','Cancel',...
      'Callback','ti_pr_ok');
   
end;