%
% Callback function for Save button for Time analysis
% Author : D. G. Childers
% Date : 3-27-97 
% 

val=get(time_save_h,'Value');

if val == 1
   
   %Start Energy Save Routine
   
   [fname pathname]=uiputfile('*.dat','Save file (ASCII)');
   cwd=pwd;
   S=sprintf('cd %s',cwd);
   eval(S);

   if fname ~= 0
      ezflag=1;
      xflag=1;
      if exist('energy') == 0
         ezflag=0;
      end
	
      if exist('xc_b') == 0
         xflag=0;
      end
      
      if ezflag == 0 & xflag == 0
         disp('Nothing to save - No time domain analysis performed');
         return;
      elseif ezflag == 1
		disp('Saving energy function');
   end
   
   S=sprintf('Saving energy in %s (ASCII format)',fname);
   disp(S);
   S=sprintf('save %s%s  energy -ascii', pathname, fname);
   eval(S);
      
else
	fname=o_fname;
	pathname=o_pname;
end

%Energy save routine ends

elseif val == 2
   
   %Start ZCR Save Routine
   
   [fname pathname]=uiputfile('*.dat','Save file (ASCII)');
   cwd=pwd;
   S=sprintf('cd %s',cwd);
   eval(S);

   if fname ~= 0
      ezflag=1;
      xflag=1;
      if exist('zcr') == 0
         ezflag=0;
      end
	
      if exist('xc_b') == 0
         xflag=0;
      end
      
      if ezflag == 0 & xflag == 0
         disp('Nothing to save - No time domain analysis performed');
         return;
      elseif ezflag == 1
		disp('Saving zcr function');
   end
   
   S=sprintf('Saving zcr in %s (ASCII format)',fname);
   disp(S);
   S=sprintf('save %s%s  zcr -ascii', pathname, fname);
   eval(S);
      
else
	fname=o_fname;
	pathname=o_pname;
end

%End zcr save routine

elseif val == 3
   
   %Start autocorrelation Save Routine
   
   [fname pathname]=uiputfile('*.dat','Save file (ASCII)');
   cwd=pwd;
   S=sprintf('cd %s',cwd);
   eval(S);

   if fname ~= 0
      ezflag=1;
      xflag=1;
      if exist('energy') == 0
         ezflag=0;
      end
	
      if exist('xc_b') == 0
         xflag=0;
      end
      
      if ezflag == 0 & xflag == 0
         disp('Nothing to save - No time domain analysis performed');
         return;
      elseif ezflag == 1
		disp('Saving the biased autocorrelation function');
   end
   
   S=sprintf('Saving energy in %s (ASCII format)',fname);
   disp(S);
   autocorrelation = xc_b;
   S=sprintf('save %s%s  autocorrelation -ascii', pathname, fname);
   eval(S);
   clear autocorrelation; 
else
	fname=o_fname;
	pathname=o_pname;
end

end


