%
% This function computes the Breathy index and the index as a function of time
% Written by Minkyu Lee
% date : 24-March-1995
%

function [nne, hnr, vnne]=xnne(sig, Ts, T)

% input
% 	sig : speech signal to be analyzed
%	Ts  : sampling period of the input signal
%	T   : pitch period

step=round((1/Ts)*2/100)	% step = 20 msec
Tlen=length(T)
len=length(sig)
factor=len/Tlen

Tp=T(1)
a=1;
b=Tp*7
i=0;

while b < len
	if Tp > 30
		[noise,signal,harm,M]=xNNEframe(sig(a:b), Tp);
		if signal > 0 & noise > 0
			i=i+1;
			NE(i)=noise
			SE(i)=signal
			HE(i)=harm
			a=a+step;
			if a < factor
				Tp=T(i);
			else
				Tp=T(a/factor);
			end
			b=a+7*Tp;
		else
			b=a+M;
		end
	end
end

vnne=10*log10(NE./SE);
nne=10*log10(mean(NE)/mean(SE));
hnr=10*log10(mean(HE)/mean(NE));
